#-*- coding: utf-8 -*-

# Copyright 2008-2010 Mir Calculate Ltd. http://www.calculate-linux.org
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.

import os
from cl_datavars import glob_attr
from  cl_utils import genpassword
from encrypt import getHash

class fillVars(glob_attr):
    addDn = lambda x,*y: ",".join(y)
    genDn = lambda x,*y: "=".join(y)

    def get_ld_temp_dn(self):
        #DN временного пользователя root (для инициализации базы данных)
        return self.addDn(self.genDn("cn", "ldaproot"), self.Get('ld_base_dn'))

    def get_ld_temp_pw(self):
        """пароль временного пользователя root"""
        return genpassword()

    def get_ld_temp_hash(self):
        """hash пароля временного root"""
        return getHash(self.Get('ld_temp_pw'), self.Get('ld_encrypt'))

    def get_ld_ldap_access_pw_conf(self):
        """строки доступа к аттрибуту userPassword в slapd.conf"""
        return '    by dn="%s" write' %self.Get("ld_admin_dn")

    def get_ld_ldap_access_dn_conf(self):
        """строки доступа к LDAP DN сервиса в slapd.conf"""
        templStart = 'access to dn.regex=".*%(repl_dn)s$"\n'\
                     '    by dn="%(admin_dn)s" write\n'\
                     '    by dn="%(repl_dn)s" write\n'\
                     '    by dn="%(bind_dn)s" read\n'
        templMail =  '    by dn="%(mail_dn)s" read\n'
        templEnd =   '    by * none'
        templ = ""
        if self.Get("ld_repl_set")=="on" and self.Get("ld_repl_id")!="":
            templ += templStart
            templDict = {'admin_dn':self.Get("ld_admin_dn"),
                         'repl_dn':self.Get("ld_repl_dn"),
                         'bind_dn':self.Get("ld_bind_dn")}
            mailDn = self.clGetVar("calculate-mail", "cl_mail_dn")
            if mailDn:
                templDict.update({'mail_dn':mailDn})
                templ += templMail
            templ += templEnd
            return templ%templDict
        return ""
